STOREA	= $20
STOREX 	= $21
STOREY 	= $22
LOCAY 	= $23		; 2 BYTES, loc to write a note
NOTNMB	= $25		; 2 BYTES, note counter
OLDLOC	= $27		; 2 BYTES, previous note start addr
TEMPX	= $29		; 
WORK	= $2A		; note entry workspace, 6 BYTES
			; 0=note 1=nat/flat/sharp 2=octave 3=length 4=temp length
			; 5=temp octave


* = $0DD0

	CLD
	LDA #$8C	; ENTER DEFAULT STARTING ADDRESS FOR SONG DATA
	STA LOCAY
	LDA #$02
	STA LOCAY+1
	LDA #$01	; init note counter
	STA NOTNMB
	LDA #$00
	STA NOTNMB+1
	LDX #$05	; clear WORK area
LOOP1	STA WORK,X
	DEX
	BPL LOOP1
	JSR OPEN	; print title, etc
	


MESS1	LDX #MSG1-MSGBAS    ; display 'want new start addr?'
        JSR SNDMSG
	LDA #$24
	JSR CHROUT	; print '$'
	JSR GETBYT	; get a byte from TTY
	CMP #$FF
	BEQ MAIN	; no, go to start MAIN loop
	STA LOCAY+1	; get the addr and store
	JSR GETBYT
	STA LOCAY

	
MAIN	JSR CRLF
	LDX #MSG3-MSGBAS	; print 'note #' msg
	JSR SNDMSG
	LDA NOTNMB+1		; print the decimal number
	JSR PRTBYT
	LDA NOTNMB
	JSR PRTBYT
	JSR OUTSPC		; SPC
	LDA #$24
	JSR CHROUT		; '$'
	LDA LOCAY+1		; load the MSB mem. addr
	STA OLDLOC+1		; save it
	JSR PRTBYT		; print it
	LDA LOCAY		; same with LSB of mem. addr
	STA OLDLOC
	JSR PRTBYT


LVT	JSR CRLF
	LDX #MSG2-MSGBAS    ; display 'want new voice/tempo?'
        JSR SNDMSG
	JSR GETKEY	; get a Y/N answer
	CMP #$59	; is it 'Y'?
	BEQ LVT_GO
	JMP GETNOT	; no, goto note processing
LVT_GO	JSR CRLF
	LDX #MSG6-MSGBAS    ; display 'V/T?' msg
        JSR SNDMSG
	JSR GETKEY
	CMP #$56	; is it 'V'?
	BEQ VOICE
	CMP #$54	; is it 'T'?
	BEQ TEMPO
	JMP LVT		; not those, so try agn


VOICE	JSR CRLF
	LDA #$56	; 'V'
	JSR PROMPT
	JSR GETKEY	; get tty char
	SEC
	SBC #$30	; reduce ASCII to $ numeral
	CMP #$03	; is it >=3? (ONLY 2 VOICES)
	BCC NEWVOX	; no, branch away
	BCS VOICE
NEWVOX  CMP #$00
	BEQ VOICE	; don't want zero
	CMP #$01	
	BEQ DOSINE	; it's 1, so we want mod sine
	LDA #$FF	; want noise
	TAX
	BNE PUTVOX	; uncond branch
DOSINE	LDA #$00	; mod sine code
	TAX
PUTVOX	LDA #$FE	; VOICE code
	JSR STORIT
	TXA
	JSR STORIT
	JMP LVT

TEMPO	JSR CRLF
	LDA #$54	; 'T'
	JSR CHROUT
	LDA #$24	; '$'
	JSR PROMPT
	JSR GETBYT	; get 2-digit $ byte from TTY
	CMP #$81	; slowest tempo (lento) allowed is $80
	BCS TEMPO
	CMP #$10	; fastest tempo (prestissimo) is $10
	BCC TEMPO
	TAX
	LDA #$FB	; TEMPO code
	JSR STORIT
	TXA
	JSR STORIT
	JMP LVT

; =================================================
; MAIN NOTE INTAKE ROUTINE
; =================================================


GETNOT	JSR CRLF
	LDA #$4E	; 'N'
	JSR PROMPT
	JSR GETKEY
	CMP #$49	; highest note allowed is H, a rest (if >=I...) 
	BCS GETNOT
	CMP #$41	; lowest note allowed is A (if <A...)
	BCC GETNOT
	STA WORK	; store the value in work area

PRMSG7	JSR GETKEY	
	CMP #$4E	; is it 'N' (natural)?
	BEQ N_NAT
	CMP #$46	; is it 'F' (flat)?
	BEQ N_FLAT
	CMP #$53	; is it 'S' (sharp)?
	BEQ N_SHRP
	JMP PRMSG7	; not those, so try agn

N_NAT	LDA #$00	; no change to lookup routine
	STA WORK+1
	BEQ OCTAVE	; uncond branch
N_FLAT	LDA #$FF	; will -1 to lookup routine
	STA WORK+1
	BNE OCTAVE	; uncond branch
N_SHRP	LDA #$01	; will +1 to lookup routine
	STA WORK+1

OCTAVE	JSR GETKEY
	SEC
	SBC #$30
	CMP #$05	; highest octave is 4
	BCS OCTAVE	; if >4 invalid
	CMP #$00	; lowest octave is 1
	BEQ OCTAVE
	STA WORK+2


LENGTH	JSR OUTSPC
	JSR OUTSPC
	LDA #$4C	; 'L'
	JSR PROMPT
	JSR GETKEY	; get tty char
	SEC
	SBC #$30	; reduce ASCII to $ numeral
	CMP #$08	; is it 8? (for whole notes)
	BEQ NOTE_L	; YES, branch away
	CMP #$06	; is it 6? (dotted half)
	BEQ NOTE_L	; YES, branch away	
	CMP #$04	; is it 4? (for half notes)
	BEQ NOTE_L	; YES, branch away
	CMP #$03	; is it 3? (dotted quarter)
	BEQ NOTE_L	; YES, branch away
	CMP #$02	; is it 2? (for quarter notes)
	BEQ NOTE_L	; YES, branch away
	CMP #$01	; is it 1? (for eighth notes)
	BEQ NOTE_L	; YES, branch away
	BNE LENGTH	; none of them, so try agn
NOTE_L	STA WORK+3	; put length in work area
	
; =================================================
; PROCESS 'WORK' DATA: LEN, OCT, NOTE
; =================================================


	LDA WORK+3	; load note length factor
	CMP #$01	; is 1/8 note?
	BEQ SETOCT	; yes, jump around
	
IS_248	CMP WORK+4	; temp length store prev note
	BEQ SETOCT	; no need to change if it's the same
	STA WORK+4	; first, store note length
	TAX
	LDA #$FC	
	JSR STORIT	; store 'change length' code
	TXA
	JSR STORIT	; store new length
	
SETOCT	LDA WORK+2	; load octave #
	CMP #$01	; is new octave the lowest register?
	BEQ CHEK_5	; yes, go see if WORK+5 <> 1

	LDA WORK+5	; no, so get last octave
	CMP #$01	; is it 1?
	BEQ FIX_HI	; yes, change to HIGH registers
	BNE STORE2	; no, just store new register in prev temp space
CHEK_5	LDA WORK+5	; new oct=1, so load old octave in A
	CMP #$01	; is it 1?
	BNE FIX_LO	; no, change to LOW
	BEQ STORE2	; else, just store new register in prev temp space
FIX_LO	LDA #$FD	
	JSR STORIT	; store 'change octave' code
	LDA #$02
	JSR STORIT	; store low octave marker (2=low octave 1)
	BNE STORE2	; uncond branch
FIX_HI	LDA #$FD	
	JSR STORIT	; store 'change octave' code
	LDA #$01
	JSR STORIT	; store higher octaves marker (1=octaves 2-3-4)
STORE2	LDA WORK+2	; put new register/octave into temp area
	STA WORK+5


IS_234	LDA WORK	; get the ASCII note value ($41-$48)
	SEC
	SBC #$40	; subtr to get number 1-8
	ASL		; double it to get natural note on table
	LDX WORK+2	; get octave #
	CPX #$04	
	BEQ CHEK_4	; IF 4 go around
	CPX #$03
	BNE OFFSET	; if not 3 (i.e. '2') go around
	CLC		; +#16 the note offset for higher notes (oct. 3)
	ADC #$10

OFFSET	CLC
	ADC WORK+1	; add $FF for flat, $01 for sharp, $00 for natural
	TAX
	BNE PUTNOT	; uncond branch
CHEK_4	LDA #$22	; the high A note (last in table)
	TAX

PUTNOT	STX TEMPX	; store the note index
IS_OK	JSR CRLF
	LDX #MSG5-MSGBAS  ; 'Store note or Redo' msg?
	JSR SNDMSG
	JSR GETKEY
	CMP #$53	; is it 'S'?
	BEQ DO_IT	; yes, DO IT!
	CMP #$52	; is it 'R'?
	BNE IS_OK	; no, try agn
	LDA OLDLOC	; restore the prev. start loc of the current note
	STA LOCAY
	LDA OLDLOC+1
	STA LOCAY+1
	JMP MAIN	; yes, start agn for this note


DO_IT	LDX TEMPX
	LDA TABLE,X	; get the right note
	LDX WORK+3	; put curr note length into X
	CPX #$02	; 
	BCC DO_IT2	; it's <2 (1) so go around
	ORA #$80	; set high bit for > 1/8 note
DO_IT2	JSR STORIT
	JSR CRLF
	LDX #MSG4-MSGBAS	; done?
	JSR SNDMSG
	JSR GETKEY
	CMP #$59	; is it 'Y'?
	BEQ GOEXIT	; yes, exit. if no....

NEXTAD	SED		; whoa! DECIMAL mode!!!
	CLC
	LDA NOTNMB	; bump note # +1
	ADC #$01
	STA NOTNMB
	LDA NOTNMB+1
	ADC #$00
	STA NOTNMB+1
	CLD		; back to HEX mode and get next note
	JSR CRLF
	JMP MAIN
	
GOEXIT	LDA #$FA	; end of tune marker/code
	JSR STORIT
	JSR CRLF
	LDX #MSG8-MSGBAS	; end addr msg
	JSR SNDMSG
	LDA LOCAY+1	; addr msb
	JSR $1E3B	; call PRTBYT
	LDA LOCAY	; addr lsb
	JSR $1E3B	; call PRTBYT
	JSR CRLF
	JMP $1C4F	; start KIM-1 monitor




; =================================================
; SUBROUTINES
; =================================================

STORIT	LDY #$00
	STA (LOCAY),Y
	CLC
	LDA LOCAY
	ADC #$01
	STA LOCAY
	LDA LOCAY+1
	ADC #$00
	STA LOCAY+1
	RTS


PROMPT	JSR $1EA0	; OUTCH what's passed in A
JUSCLN	LDA #$3A	; ':'
	JSR $1EA0	; OUTCH
	JSR OUTSPC	; a space
	RTS


OPEN	LDX #$00
PRINT3	LDA TITLE,X
	BEQ RETRN3	
	JSR $1EA0
	INX
	BNE PRINT3
RETRN3	RTS


SNDMSG	LDA MSGBAS,X
	BEQ RETRN2	
	JSR $1EA0
	INX
	BNE SNDMSG
RETRN2	RTS



STOREM  STA STOREA        ; STORE THE REGISTERS
	STX STOREX
	STY STOREY
	RTS

GETKEY  JSR STOREM
	JSR $1E5A        ; CALL GETCH
	JMP XYBACK

CHROUT  JSR STOREM
	JSR $1EA0        ; CALL OUTCH
RESTOR  LDA STOREA        ; RESTORE THE REGISTERS
XYBACK  LDX STOREX
	LDY STOREY
	RTS

CRLF	JSR STOREM
	JSR $1E2F
	JMP RESTOR

GETBYT	JSR STOREM
	JSR $1F9D	; CALL GETBYT
	JMP XYBACK

PRTBYT	JSR STOREM
	JSR $1E3B	; call PRTBYT
	JMP XYBACK

OUTSPC	JSR STOREM
	JSR $1E9E	; call OUTSP
	JMP XYBACK


TABLE
.BYTE $00,$00,$75,$6E,$68,$68,$62,$5C,$57,$52,$4D,$4D,$48,$44,$40,$3C,$00,$00
.BYTE $39,$36,$32,$32,$30,$2D,$2A,$27,$25,$25,$23,$21,$1F,$1D,$00,$00
.BYTE $1B,$00


; message table
MSGBAS  =*

MSG1
.BYTE "Input song start addr (FF=default): "
.BYTE $00

MSG2
.BYTE "Voice or Tempo change? (Y/N): "
.BYTE $00

MSG3
.BYTE "Note #: "
.BYTE $00

MSG4
.BYTE "Done? (Y/N): "
.BYTE $00

MSG5
.BYTE "(S)tore or (R)edo? "
.BYTE $00

MSG6
.BYTE "Enter V or T: "
.BYTE $00

MSG8
.BYTE "Song end addr: $"
.BYTE $00



TITLE
.BYTE $0A,$0D,$0A,$0D
.BYTE "Melody Maker -- by Dave Hassler"
.BYTE $0A,$0D
.BYTE "for Jim Butterfield's MUSIC BOX"
.BYTE $0A,$0D,$0A,$0D
.BYTE "Enter:"
.BYTE $0A,$0D
.BYTE "   A) change tempo/voice of the note (Y/N)"
.BYTE $0A,$0D
.BYTE "   B) note: base, flat/nat/sharp, octave (e.g. FS1=low F#)"
.BYTE $0A,$0D
.BYTE "   C) type: 1, 2, 3, 4, 6, 8 (e.g. 2=quarter, 8=whole)"
.BYTE $0A,$0D,$0A,$0D,$00
